/* Projekt      : YTREE 
 * Autor        : W. Bregulla
 * Modul        : config.h
 * Datum        : 01.02.93
 * Version      : 1.0
 * Beschreibung : Header-Datei fuer YTREE
 * History
 */


/* Die hier angegebenen Werte werden benutzt, falls die entsprechende
 * Environment-Variable nicht gesetzt wird.
 * Der Name der Environment-Variablen leitet sich aus dem Macro-Namen ab:
 * Z.B. bei DEFAULT_CAT   : CAT
 *          DEFAULT_EDITOR: EDITOR usw.
 */


/* Auswahl der benutzten UNIX-Kommandos */
/*--------------------------------------*/

#define DEFAULT_CAT        "cat"
#define DEFAULT_EDITOR     "vi"
#define DEFAULT_MELT       "melt"
#define DEFAULT_UNCOMPRESS "uncompress"
#define DEFAULT_GNUUNZIP   "gunzip -c"
#define DEFAULT_MANROFF    "nroff -man"


/* Achtung ! Hier muss (?) GNU-Tar benutzt werden, da
 * nur GNU-Tar in der Lage ist auf stdout zu extrahieren (Option O) !!!
 */

#define DEFAULT_TARLIST    "gtar tvf -"
#define DEFAULT_TAREXPAND  "gtar xOPf -"
#define DEFAULT_HEXDUMP    "hd"
#define DEFAULT_PAGER      "more"
#define DEFAULT_PAGEOPT    ""

#ifdef linux
# undef DEFAULT_TARLIST
# undef DEFAULT_TAREXPAND
# undef DEFAULT_HEXDUMP
# undef DEFAULT_PAGER
# undef DEFAULT_PAGEOPT
# define DEFAULT_TARLIST    "tar tvf -"
# define DEFAULT_TAREXPAND  "tar xOPf -"
# define DEFAULT_HEXDUMP    "od -h"
# define DEFAULT_PAGER      "less"
# define DEFAULT_PAGEOPT    "-cen"
#endif

#ifdef SCO
# undef DEFAULT_TARLIST
# undef DEFAULT_TAREXPAND
# undef DEFAULT_HEXDUMP
# undef DEFAULT_PAGER
# undef DEFAULT_PAGEOPT
# define DEFAULT_TARLIST    "tar tvf -"
# define DEFAULT_TAREXPAND  "tar xOPf -"
# define DEFAULT_HEXDUMP    "od -h"
# define DEFAULT_PAGER      "less"
# define DEFAULT_PAGEOPT    "-cen"
#endif

#ifdef __NeXT__
/* fifi's NeXT! */
# undef DEFAULT_TARLIST
# undef DEFAULT_TAREXPAND
# undef DEFAULT_HEXDUMP
# undef DEFAULT_PAGER
# undef DEFAULT_PAGEOPT
# define DEFAULT_TARLIST    "gtar tvf -"
# define DEFAULT_TAREXPAND  "gtar xOPf -"
# define DEFAULT_HEXDUMP    "hd"
# define DEFAULT_PAGER      "less"
# define DEFAULT_PAGEOPT    "-cen"
#endif

#define DEFAULT_ZOOLIST    "zoo vm"
#define DEFAULT_ZOOEXPAND  "zoo xp"

#define DEFAULT_ZIPLIST    "zipinfo -l"
#define DEFAULT_ZIPEXPAND  "unzip -c"

#define DEFAULT_LHALIST    "xlharc v"
#define DEFAULT_LHAEXPAND  "xlharc p"

#define DEFAULT_ARCLIST    "arc v"
#define DEFAULT_ARCEXPAND  "arc p"

