/* Projekt      : YTREE
 * Autor        : W. Bregulla
 * Modul        : init.c
 * Datum        : 10.07.91
 * Version      : 1.0
 * Beschreibung : Initialisierungen
 * History
 */


#include "ytree.h"


extern void exit(int);


int Init(void)
{
  initscr();
  
  cbreak();
  noecho();
  nonl();
  keypad( stdscr, TRUE );

  if( LINES < MIN_HEIGHT || COLS < MIN_WIDTH )
  {
    endwin();
   
    (void) fprintf( stderr, "Screen too small: min=%d x %d\n",
		    MIN_HEIGHT, MIN_WIDTH
		  );
    return( 1 );
  }


  dir_window = subwin( stdscr, 
		       DIR_WINDOW_HEIGHT, 
		       DIR_WINDOW_WIDTH, 
		       DIR_WINDOW_Y, 
		       DIR_WINDOW_X
		      );
  
  keypad( dir_window, TRUE );
  scrollok( dir_window, TRUE );
  
  small_file_window = subwin( stdscr, 
			      FILE_WINDOW_1_HEIGHT, 
			      FILE_WINDOW_1_WIDTH, 
			      FILE_WINDOW_1_Y, 
		              FILE_WINDOW_1_X
		           );
  
  keypad( small_file_window, TRUE );
  
  big_file_window = subwin( stdscr, 
			    FILE_WINDOW_2_HEIGHT, 
			    FILE_WINDOW_2_WIDTH, 
			    FILE_WINDOW_2_Y, 
		            FILE_WINDOW_2_X
		          );
  
  keypad( big_file_window, TRUE );
 


  error_window = newwin( 
		       ERROR_WINDOW_HEIGHT, 
		       ERROR_WINDOW_WIDTH, 
		       ERROR_WINDOW_Y, 
		       ERROR_WINDOW_X
		      );
  
 
  if( baudrate() >= QUICK_BAUD_RATE ) typeahead( -1 );

  file_window = small_file_window;


  if( ReadGroupEntries() )
  {
    ERROR( "ReadGroupEntries failed*ABORT" );
    exit( 1 );
  }
  
  if( ReadPasswdEntries() )
  {
    ERROR( "ReadPasswdEntries failed*ABORT" );
    exit( 1 );
  }

  SetFileMode( MODE_3 );
  SetKindOfSort( SORT_BY_NAME );

  return( 0 );
}


