/* Projekt      : YTREE
 * Autor        : W. Bregulla
 * Modul        : match.c
 * Datum        : 10.07.91
 * Version      : 1.0
 * Beschreibung : Behandlung reg. Ausdruecke fuer Filenamen
 * History
 */


#include "ytree.h"

#if defined( bsd ) || defined( sun ) || defined( linux ) || defined( __NeXT__ )
#define HAS_REGEX
#endif



#ifdef HAS_REGEX
#include <regex.h>
#else
extern char *regcmp();
extern char *regex();
extern void exit(int);
static char *file_spec_cmp = NULL;

#endif /* HAS_REGEX */





int SetMatchSpec(char *new_spec)
{
  char *result;
  char *buffer;
  char *b_ptr;
  BOOL meta_flag = FALSE;

  if( ( buffer = malloc( strlen( new_spec ) * 2 + 4 ) ) == NULL )
  {
    ERROR( "Malloc failed*ABORT" );
    exit( 1 );
  }

  b_ptr = buffer;
  *b_ptr++ = '^';

  for(; *new_spec; new_spec++)
  {
    if( meta_flag ) 
    {
      *b_ptr++ = *new_spec;
      meta_flag = FALSE;
    }
    else if( *new_spec == '\\' ) meta_flag = TRUE;
    else if( *new_spec == '?' ) *b_ptr++ = '.';
    else if( *new_spec == '.' )
    {
      *b_ptr++ = '\\';
      *b_ptr++ = '.';
    }
    else if( *new_spec == '*' )
    {
      *b_ptr++ = '.';
      *b_ptr++ = '*';
    }
    else
      *b_ptr++ = *new_spec;
  }

  *b_ptr++ = '$';
  *b_ptr = '\0';

#if defined ( HAS_REGEX )

  if( ( result = re_comp( buffer ) ) )
  {
    free( buffer );
    return( 1 );
  }

#elif !defined( WIN32 )

  if( ( result = regcmp( buffer, (char *) 0 ) ) == NULL )
  {
    free( buffer );
    return( 1 );
  }

  if( file_spec_cmp ) free( file_spec_cmp );
  free( buffer );

  file_spec_cmp = result;

#else

  /* WIN32 */

  /* z.Z. nicht unterstuetzt */

  free( buffer );
  result = 0;

#endif /* HAS_REGEX */

  return( 0 );
}

BOOL Match(char *file_name)
{
/* herrmann */
return( TRUE );
}

BOOL Matchh(char *file_name)
{
#if defined ( HAS_REGEX )
  
  if( re_exec( file_name ) ) return( TRUE );
  else                       return( FALSE );

#elif !defined( WIN32 )

  char match_part[PATH_LENGTH + 1];

  if( !file_spec_cmp )
    return( TRUE );

  if( regex( file_spec_cmp, file_name, match_part ) == NULL )
    return( FALSE );

  return( TRUE );

#else

  /* WIN32 */

  /* z.Z. nicht unterstuetzt */

  return( TRUE );

#endif /* HAS_REGEX */
}

  
  
