/* Projekt      : YTREE
 * Autor        : W. Bregulla
 * Modul        : rmdir.c
 * Datum        : 10.07.91
 * Version      : 1.0
 * Beschreibung : Loeschen von Verzeichnissen
 * History
 */


#include "ytree.h"


extern char *sys_errlist[];



int DeleteDirectory(DirEntry *dir_entry)
{
  char buffer[PATH_LENGTH+1];
  int result = -1;

  if( mode != DISK_MODE )
  {
    beep();
    return( result );
  }

  ClearHelp();

  if( dir_entry == statistic.tree )
  {
    MESSAGE( "Can't delete ROOT" );
  }
  else if( dir_entry->file || dir_entry->sub_tree )
  {
    MESSAGE( "Directory not empty!" );
  }
  else if( InputChoise( "Delete this directory (Y/N) ? ", "YN\033" ) == 'Y' )
  {
    (void) GetPath( dir_entry, buffer );

    if( access( buffer, W_OK ) )
    {
      (void) sprintf( message, "Can't delete directory*\"%s\"*%s", 
		      buffer, sys_errlist[errno]
		    );
      MESSAGE( message );
    }
    else if( rmdir( buffer ) )
    {
      (void) sprintf( message, "Can't delete directory*\"%s\"*%s", 
		      buffer, sys_errlist[errno]
		    );
      MESSAGE( message );
    }
    else
    {
      /* Directory geloescht 
       * ==> aus Baum loeschen
       */
      
      statistic.disk_total_directories--;

      if( dir_entry->prev ) dir_entry->prev->next = dir_entry->next;
      else dir_entry->up_tree->sub_tree = dir_entry->next;

      if( dir_entry->next ) dir_entry->next->prev = dir_entry->prev;

      free( dir_entry );

      (void) GetAvailBytes( &statistic.disk_space );

      result = 0;
    }
  }
 
  return( result );
}





